# ======= GENERAL SETTINGS: Adapt these per assignment =============
ASSIGNMENT = "Duke ECE/CS 250 Homework 5"
SEMESTER = "Fall 2018"
TEST_DIR = 'tests' # where test files are located
IS_GRADER = False # if true, we'll expect to see a 'points' parameter in test setup

SPIM_BINARY = 'spim' # location of spim executable (or just 'spim' if in path); only needed if mode is SPIM
LOGISIM_JAR = 'logisim_cli.jar' # location of logisim_cli.jar; only needed if mode is LOGISIM

# modes: 
#   EXECUTABLE - for C programs, etc.
#   SPIM       - run with command line spim
#   LOGISIM    - run with logisim command-line front-end
MODE = 'EXECUTABLE'

NON_ZERO_EXIT_STATUS_PENALTY = 0.75 # multiply score by this if exit status is non-zero
VALGRIND_PENALTY = 1.0 # multiply score by this if a valgrind test showed a leak

# ============= TEST SETUP ========================
suite_names = ('virt2phys', 'cachesim')
suites = {
    "virt2phys": [
        { "desc": "pagetable-8a.txt  addr=0", "args": ['pagetables/pagetable-8a.txt','0'] },
        { "desc": "pagetable-8a.txt  addr=f", "args": ['pagetables/pagetable-8a.txt','f'] },
        { "desc": "pagetable-8a.txt  addr=10", "args": ['pagetables/pagetable-8a.txt','10'] },
        { "desc": "pagetable-8a.txt  addr=58", "args": ['pagetables/pagetable-8a.txt','58'] },
        { "desc": "pagetable-8a.txt  addr=d4", "args": ['pagetables/pagetable-8a.txt','d4'] },
        { "desc": "pagetable-8a.txt  addr=ff", "args": ['pagetables/pagetable-8a.txt','ff'] },
        { "desc": "pagetable-8b.txt  addr=0", "args": ['pagetables/pagetable-8b.txt','0'] },
        { "desc": "pagetable-8b.txt  addr=f", "args": ['pagetables/pagetable-8b.txt','f'] },
        { "desc": "pagetable-8b.txt  addr=10", "args": ['pagetables/pagetable-8b.txt','10'] },
        { "desc": "pagetable-8b.txt  addr=58", "args": ['pagetables/pagetable-8b.txt','58'] },
        { "desc": "pagetable-8b.txt  addr=d4", "args": ['pagetables/pagetable-8b.txt','d4'] },
        { "desc": "pagetable-8b.txt  addr=ff", "args": ['pagetables/pagetable-8b.txt','ff'] },
        { "desc": "pagetable-8c.txt  addr=0", "args": ['pagetables/pagetable-8c.txt','0'] },
        { "desc": "pagetable-8c.txt  addr=f", "args": ['pagetables/pagetable-8c.txt','f'] },
        { "desc": "pagetable-8c.txt  addr=10", "args": ['pagetables/pagetable-8c.txt','10'] },
        { "desc": "pagetable-8c.txt  addr=58", "args": ['pagetables/pagetable-8c.txt','58'] },
        { "desc": "pagetable-8c.txt  addr=d4", "args": ['pagetables/pagetable-8c.txt','d4'] },
        { "desc": "pagetable-8c.txt  addr=ff", "args": ['pagetables/pagetable-8c.txt','ff'] },
        { "desc": "pagetable-24a.txt addr=0", "args": ['pagetables/pagetable-24a.txt','0'] },
        { "desc": "pagetable-24a.txt addr=3f", "args": ['pagetables/pagetable-24a.txt','3f'] },
        { "desc": "pagetable-24a.txt addr=40", "args": ['pagetables/pagetable-24a.txt','40'] },
        { "desc": "pagetable-24a.txt addr=fff", "args": ['pagetables/pagetable-24a.txt','fff'] },
        { "desc": "pagetable-24a.txt addr=1000", "args": ['pagetables/pagetable-24a.txt','1000'] },
        { "desc": "pagetable-24a.txt addr=1fa4", "args": ['pagetables/pagetable-24a.txt','1fa4'] },
        { "desc": "pagetable-24a.txt addr=f4240", "args": ['pagetables/pagetable-24a.txt','f4240'] },
        { "desc": "pagetable-24a.txt addr=6fffff", "args": ['pagetables/pagetable-24a.txt','6fffff'] },
        { "desc": "pagetable-24a.txt addr=700000", "args": ['pagetables/pagetable-24a.txt','700000'] },
        { "desc": "pagetable-24a.txt addr=700001", "args": ['pagetables/pagetable-24a.txt','700001'] },
        { "desc": "pagetable-24a.txt addr=ffffff", "args": ['pagetables/pagetable-24a.txt','ffffff'] },
        { "desc": "pagetable-24b.txt addr=0", "args": ['pagetables/pagetable-24b.txt','0'] },
        { "desc": "pagetable-24b.txt addr=3f", "args": ['pagetables/pagetable-24b.txt','3f'] },
        { "desc": "pagetable-24b.txt addr=40", "args": ['pagetables/pagetable-24b.txt','40'] },
        { "desc": "pagetable-24b.txt addr=fff", "args": ['pagetables/pagetable-24b.txt','fff'] },
        { "desc": "pagetable-24b.txt addr=1000", "args": ['pagetables/pagetable-24b.txt','1000'] },
        { "desc": "pagetable-24b.txt addr=1fa4", "args": ['pagetables/pagetable-24b.txt','1fa4'] },
        { "desc": "pagetable-24b.txt addr=f4240", "args": ['pagetables/pagetable-24b.txt','f4240'] },
        { "desc": "pagetable-24b.txt addr=6fffff", "args": ['pagetables/pagetable-24b.txt','6fffff'] },
        { "desc": "pagetable-24b.txt addr=700000", "args": ['pagetables/pagetable-24b.txt','700000'] },
        { "desc": "pagetable-24b.txt addr=700001", "args": ['pagetables/pagetable-24b.txt','700001'] },
        { "desc": "pagetable-24b.txt addr=ffffff", "args": ['pagetables/pagetable-24b.txt','ffffff'] },
        { "desc": "pagetable-24c.txt addr=0", "args": ['pagetables/pagetable-24c.txt','0'] },
        { "desc": "pagetable-24c.txt addr=3f", "args": ['pagetables/pagetable-24c.txt','3f'] },
        { "desc": "pagetable-24c.txt addr=40", "args": ['pagetables/pagetable-24c.txt','40'] },
        { "desc": "pagetable-24c.txt addr=fff", "args": ['pagetables/pagetable-24c.txt','fff'] },
        { "desc": "pagetable-24c.txt addr=1000", "args": ['pagetables/pagetable-24c.txt','1000'] },
        { "desc": "pagetable-24c.txt addr=1fa4", "args": ['pagetables/pagetable-24c.txt','1fa4'] },
        { "desc": "pagetable-24c.txt addr=f4240", "args": ['pagetables/pagetable-24c.txt','f4240'] },
        { "desc": "pagetable-24c.txt addr=6fffff", "args": ['pagetables/pagetable-24c.txt','6fffff'] },
        { "desc": "pagetable-24c.txt addr=700000", "args": ['pagetables/pagetable-24c.txt','700000'] },
        { "desc": "pagetable-24c.txt addr=700001", "args": ['pagetables/pagetable-24c.txt','700001'] },
        { "desc": "pagetable-24c.txt addr=ffffff", "args": ['pagetables/pagetable-24c.txt','ffffff'] },
        { "desc": "pagetable-24d.txt addr=0", "args": ['pagetables/pagetable-24d.txt','0'] },
        { "desc": "pagetable-24d.txt addr=3f", "args": ['pagetables/pagetable-24d.txt','3f'] },
        { "desc": "pagetable-24d.txt addr=40", "args": ['pagetables/pagetable-24d.txt','40'] },
        { "desc": "pagetable-24d.txt addr=fff", "args": ['pagetables/pagetable-24d.txt','fff'] },
        { "desc": "pagetable-24d.txt addr=1000", "args": ['pagetables/pagetable-24d.txt','1000'] },
        { "desc": "pagetable-24d.txt addr=1fa4", "args": ['pagetables/pagetable-24d.txt','1fa4'] },
        { "desc": "pagetable-24d.txt addr=f4240", "args": ['pagetables/pagetable-24d.txt','f4240'] },
        { "desc": "pagetable-24d.txt addr=6fffff", "args": ['pagetables/pagetable-24d.txt','6fffff'] },
        { "desc": "pagetable-24d.txt addr=700000", "args": ['pagetables/pagetable-24d.txt','700000'] },
        { "desc": "pagetable-24d.txt addr=700001", "args": ['pagetables/pagetable-24d.txt','700001'] },
        { "desc": "pagetable-24d.txt addr=ffffff", "args": ['pagetables/pagetable-24d.txt','ffffff'] },

    ],
    "cachesim": [
        { "desc": "beef1.txt     16kB  1way bs=8  ", "args": ['traces/beef1.txt','16','1','8'] },
        { "desc": "beef2.txt     16kB  1way bs=8  ", "args": ['traces/beef2.txt','16','1','8'] },
        { "desc": "beef3.txt     16kB  1way bs=8  ", "args": ['traces/beef3.txt','16','1','8'] },
        { "desc": "border1.txt    2kB  1way bs=64 ", "args": ['traces/border1.txt','2','1','64'] },
        { "desc": "border1.txt    2kB  2way bs=64 ", "args": ['traces/border1.txt','2','2','64'] },
        { "desc": "border1.txt    2kB  4way bs=64 ", "args": ['traces/border1.txt','2','4','64'] },
        { "desc": "border1.txt    2kB  8way bs=64 ", "args": ['traces/border1.txt','2','8','64'] },
        { "desc": "border2.txt    2kB  1way bs=64 ", "args": ['traces/border2.txt','2','1','64'] },
        { "desc": "border2.txt    2kB  2way bs=64 ", "args": ['traces/border2.txt','2','2','64'] },
        { "desc": "border2.txt    2kB  4way bs=64 ", "args": ['traces/border2.txt','2','4','64'] },
        { "desc": "border2.txt    2kB  8way bs=64 ", "args": ['traces/border2.txt','2','8','64'] },
        { "desc": "walk1.txt      8kB  1way bs=4  ", "args": ['traces/walk1.txt','8','1','4'] },
        { "desc": "walk1.txt      8kB  1way bs=8  ", "args": ['traces/walk1.txt','8','1','8'] },
        { "desc": "walk1.txt      8kB  1way bs=16 ", "args": ['traces/walk1.txt','8','1','16'] },
        { "desc": "walk1.txt      8kB  1way bs=32 ", "args": ['traces/walk1.txt','8','1','32'] },
        { "desc": "walk1.txt      8kB  1way bs=64 ", "args": ['traces/walk1.txt','8','1','64'] },
        { "desc": "walk2.txt      8kB  1way bs=4  ", "args": ['traces/walk2.txt','8','1','4'] },
        { "desc": "walk2.txt      8kB  1way bs=8  ", "args": ['traces/walk2.txt','8','1','8'] },
        { "desc": "walk2.txt      8kB  1way bs=16 ", "args": ['traces/walk2.txt','8','1','16'] },
        { "desc": "walk2.txt      8kB  1way bs=32 ", "args": ['traces/walk2.txt','8','1','32'] },
        { "desc": "walk2.txt      8kB  1way bs=64 ", "args": ['traces/walk2.txt','8','1','64'] },
        { "desc": "walk3.txt      8kB  1way bs=4  ", "args": ['traces/walk3.txt','8','1','4'] },
        { "desc": "walk3.txt      8kB  1way bs=8  ", "args": ['traces/walk3.txt','8','1','8'] },
        { "desc": "walk3.txt      8kB  1way bs=16 ", "args": ['traces/walk3.txt','8','1','16'] },
        { "desc": "walk3.txt      8kB  1way bs=32 ", "args": ['traces/walk3.txt','8','1','32'] },
        { "desc": "walk3.txt      8kB  1way bs=64 ", "args": ['traces/walk3.txt','8','1','64'] },
        { "desc": "walk4.txt      8kB  1way bs=4  ", "args": ['traces/walk4.txt','8','1','4'] },
        { "desc": "walk4.txt      8kB  1way bs=8  ", "args": ['traces/walk4.txt','8','1','8'] },
        { "desc": "walk4.txt      8kB  1way bs=16 ", "args": ['traces/walk4.txt','8','1','16'] },
        { "desc": "walk4.txt      8kB  1way bs=32 ", "args": ['traces/walk4.txt','8','1','32'] },
        { "desc": "walk4.txt      8kB  1way bs=64 ", "args": ['traces/walk4.txt','8','1','64'] },
        { "desc": "captest1.txt   1kB  1way bs=128", "args": ['traces/captest1.txt','1','1','128'] },
        { "desc": "captest1.txt   1kB  2way bs=128", "args": ['traces/captest1.txt','1','2','128'] },
        { "desc": "captest1.txt   1kB  4way bs=128", "args": ['traces/captest1.txt','1','4','128'] },
        { "desc": "captest1.txt   1kB  8way bs=128", "args": ['traces/captest1.txt','1','8','128'] },
        { "desc": "captest1.txt   2kB  1way bs=128", "args": ['traces/captest1.txt','2','1','128'] },
        { "desc": "captest1.txt   2kB  2way bs=128", "args": ['traces/captest1.txt','2','2','128'] },
        { "desc": "captest1.txt   2kB  4way bs=128", "args": ['traces/captest1.txt','2','4','128'] },
        { "desc": "captest1.txt   2kB  8way bs=128", "args": ['traces/captest1.txt','2','8','128'] },
        { "desc": "captest1.txt   2kB 16way bs=128", "args": ['traces/captest1.txt','2','16','128'] },
        { "desc": "captest2.txt   1kB  1way bs=128", "args": ['traces/captest2.txt','1','1','128'] },
        { "desc": "captest2.txt   1kB  2way bs=128", "args": ['traces/captest2.txt','1','2','128'] },
        { "desc": "captest2.txt   1kB  4way bs=128", "args": ['traces/captest2.txt','1','4','128'] },
        { "desc": "captest2.txt   1kB  8way bs=128", "args": ['traces/captest2.txt','1','8','128'] },
        { "desc": "captest2.txt   2kB  1way bs=128", "args": ['traces/captest2.txt','2','1','128'] },
        { "desc": "captest2.txt   2kB  2way bs=128", "args": ['traces/captest2.txt','2','2','128'] },
        { "desc": "captest2.txt   2kB  4way bs=128", "args": ['traces/captest2.txt','2','4','128'] },
        { "desc": "captest2.txt   2kB  8way bs=128", "args": ['traces/captest2.txt','2','8','128'] },
        { "desc": "captest2.txt   2kB 16way bs=128", "args": ['traces/captest2.txt','2','16','128'] },
        { "desc": "random1.txt   32kB  4way bs=256", "args": ['traces/random1.txt','32','4','256'] },
        { "desc": "random1.txt  128kB  8way bs=512", "args": ['traces/random1.txt','128','8','512'] },
        { "desc": "random2.txt   32kB  4way bs=256", "args": ['traces/random2.txt','32','4','256'] },
        { "desc": "random2.txt  128kB  8way bs=512", "args": ['traces/random2.txt','128','8','512'] },


    ],
}
